/**
 * \file
 *
 * \brief USBuײ(UDD)pAPI
 *
 * 쌠 (c) 2009 - 2012 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _UDD_H_
#define _UDD_H_

#include "usb_protocol.h"
#include "udc_desc.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \ingroup usb_device_group
 * \defgroup udd_group USBuײ(UDD)
 *
 * UDDײނ͑uʰ޳̒ʒە񋟂܂B荞݂̂悤ʰ޳
 * 痈wǂ̎ۂUDDUDCUDIւ̌Ăяo邩܂B
 *
 * @{
 */

//! \brief ߲Ďʎq
typedef uint8_t udd_ep_id_t;

//! \brief ߲ē]
//! udd_ep_runٰ݌oRŌĂі߂o^ҰԂ܂B
typedef enum {
	UDD_EP_TRANSFER_OK = 0,
	UDD_EP_TRANSFER_ABORT = 1,
} udd_ep_status_t;

/**
 * \brief SETUPvǗ̏^ċL^邽߂̑S̕ϐ
 *
 * ̑S̕ϐSETUPv𕜍ĉ邱Ƃ܂BUDC
 * udc_process_setup()܂UDI*setup()ɂčXV꓾܂B
 */
typedef struct {
	//! USB SETUP߹ĂŎ󂯎ް
	//! : uin16_tle16_tւ"req.wValues"̌UDDɂčs܂B
	usb_setup_req_t req;

	//! SETUP߹Ăɔް𑗂܂͖߂̊ɏՕւ̈ʒu
	uint8_t *payload;

	//! ܂͖߂̊ɏՕ̑傫Aꂽ޲Đ̓e
	uint16_t payload_size;

	//! SETUP悤ォZLPMɌĂ΂Ăі߂
	void (*callback) (void);

	//! ^ꂽ({̂)ɏՕt܂͋̎ɌĂ΂Ăі߂
	//! ް]~falseA{̂ł̐VɏՕtrueԂ܂B
	bool(*over_under_run) (void);
} udd_ctrl_request_t;
extern udd_ctrl_request_t udd_g_ctrlreq;

//! SETUPv\a udd_g_ctrlreqINް]ꍇtrueԂ܂B
#define  Udd_setup_is_in()       \
      (USB_REQ_DIR_IN == (udd_g_ctrlreq.req.bmRequestType & USB_REQ_DIR_MASK))

//! SETUPv\a udd_g_ctrlreqOUTް]ꍇtrueԂ܂B
#define  Udd_setup_is_out()      \
      (USB_REQ_DIR_OUT == (udd_g_ctrlreq.req.bmRequestType & USB_REQ_DIR_MASK))

//! SETUPv\a udd_g_ctrlreq̌^Ԃ܂B\see usb_reqtype
#define  Udd_setup_type()        \
      (udd_g_ctrlreq.req.bmRequestType & USB_REQ_TYPE_MASK)

//! SETUPv\a udd_g_ctrlreq̎҂Ԃ܂B\see usb_recipient
#define  Udd_setup_recipient()   \
      (udd_g_ctrlreq.req.bmRequestType & USB_REQ_RECIP_MASK)

/**
 * \brief ~̍Ō̌Ăі߂֐^
 * Registered by routine udd_ep_wait_stall_clear()
 * ߲Ēf鎞ɌĂ΂Ăі߂
 */
typedef void (*udd_callback_halt_cleared_t) (void);

/**
 * \brief ]̍Ō̌Ăі߂֐^
 * Registered by routine udd_ep_run()
 * ް]܂͒~(ؾā`)USB荞݂ɂČĂ΂Ăі߂
 *
 * \param	status	]̏ꍇAUDD_EP_TRANSFER_OK
 * \param	status	]~ꂽꍇAUDD_EP_TRANSFER_ABORT
 * \param	n		]ꂽް
 */
typedef void (*udd_callback_trans_t) (udd_ep_status_t status,
		iram_size_t nb_transfered);

/**
 * \brief VBSUۂF
 *
 * \return	VBUSĎ\ȏꍇtrue
 */
bool udd_include_vbus_monitoring(void);

/**
 * \brief USBu
 */
void udd_enable(void);

/**
 * \brief USBu֎~
 */
void udd_disable(void);

/**
 * \brief \Ȏɑu޽Ɏt
 *
 * \warning VBUS䂪ײނɊ܂܂ꍇAνĂ̎󂯓\VBUS
 * oꂽɑut܂B
 */
void udd_attach(void);

/**
 * \brief ޽瑕uO
 *
 * ײނUSBD-܂D+ٱ߂OȂ΂Ȃ܂B
 */
void udd_detach(void);

/**
 * \brief USBu킪œۂ
 *
 * \return	uœꍇ\c trueAłȂ\c false
 */
bool udd_is_high_speed(void);

/**
 * \brief uUSBڽύX
 *
 * \param	address		VUSBڽ
 */
void udd_set_address(uint8_t address);

/**
 * \brief uUSBڽԂ܂B
 *
 * \return	USBڽ
 */
uint8_t udd_getaddress(void);

/**
 * \brief ݂ڰъJnԍԂ܂B
 *
 * \return	݂ڰъJnԍ
 */
uint16_t udd_get_frame_number(void);

/**
 * \brief ݂ϲ ڰъJnԍԂ܂B
 *
 * \return	ŕKvƂ錻݂ϲ ڰيJnԍ
 */
uint16_t udd_get_micro_frame_number(void);

/*! \brief USBײނ͏ĊJƌĂ΂őM𑗏o
 */
void udd_send_remotewakeup(void);

/**
 * \brief SETUP{̂ݒ
 *
 * \param	payload			{̂̈ʒuwq
 * \param	payload_size	{̂̑傫
 */
void udd_set_setup_payload( uint8_t *payload, uint16_t payload_size );


/**
 * \name ߲ĊǗ
 *
 * ȉ̊֐ײނɴ߲Ă̍쐬ƍ폜łȂA"~""lߍ
 * "̏ԂݒAA₢킹܂B
 */
//@{

#if (USB_DEVICE_MAX_EP != 0)

/**
 * \brief ߲Ă̌`ԐݒƋ
 *
 * \param	ep					(USB_EP_DIR_IN/USB_EP_DIR_OUT)܂޴߲Ĕԍ
 * \param	bmAttributes		LqqŐ錾ꂽ߲Ă̑
 * \param	MaxEndpointSize		߲Ă̍ő̑傫
 *
 * \return	߲Ăꂽꍇ\c 1AłȂ\c 0
 */
bool udd_ep_alloc(udd_ep_id_t ep, uint8_t bmAttributes,
		uint16_t MaxEndpointSize);

/**
 * \brief ߲Ă֎~
 *
 * \param	ep	(USB_EP_DIR_IN/USB_EP_DIR_OUT)܂޴߲Ĕԍ
 */
void udd_ep_free(udd_ep_id_t ep);

/**
 * \brief W߲\a ep~Ă邩
 *
 * \param	ep	ׂ߲ĂID
 *
 * \return	\a ep~Ă\c 1AłȂ\c 0
 */
bool udd_ep_is_halted(udd_ep_id_t ep);

/**
 * \brief ߲\a ep̒~Ԃݒ
 *
 * ̊֐ĂяoA\a epł̂ǂ̏o~(STALL)޼ɋA
 * ܂BǂAǂۗ̏̕ŏɎs܂B
 *
 * \param	ep	~߲ĂID
 *
 * \return	\a ep~ꂽȂ\c 1AłȂ\c 0
 */
bool udd_ep_set_halt(udd_ep_id_t ep);

/**
 * \brief ߲\a ep̒~Ԃ
 *
 * ̊֐ĂяoA\a ep̂ǂ̏ʏlɈ܂AA~(STALL)
 * ޼ꂸAްݐ؂ւ菇DATA0Ŏn܂܂B
 *
 * \param	ep	~߲ĂID
 *
 * \return	֐Ȉꍇ\c 1AłȂ\c 0
 */
bool udd_ep_clear_halt(udd_ep_id_t ep);

/**
 * \brief ߲Ē~鎞ɌĂԌĂі߂o^
 *
 * \param	ep			gp߲ĂID
 * \param	callback	NULL܂ʹ߲Ē~鎞ɌĂԂ߂̊֐
 *
 * \warning ߲Ă~ĂȂΒ\a callbackĂ΂܂B
 *
 * \return	o^󂯓ꂽꍇ\c 1AłȂ\c 0
 */
bool udd_ep_wait_stall_clear(udd_ep_id_t ep,
		udd_callback_halt_cleared_t callback);

/**
 * \brief ߲Ăłް̎܂͑oe
 *
 * ײނ͂痘p\ȏꍇɁAްRAM߲Ă֓]̂ɓ
 * DMA USBgp܂B]I܂͒~(~AؾāA`)ꂽ
 * \a callbackĂ΂܂B\a callback͓]ԂƌǁA]޲ĐԂ
 * B
 * : ߲Ă͔F؂܂B
 *
 * \param	ep				gp߲ĂID
 * \param	b_shortpacket	ꂽZ߹
 * \param	buf				܂͖߂̓RAMł̊ɏՕ
 *							͐łȂ΂Ȃ炸ACOMPILER_WORD_ALIGNED
 *							gpĂB
 * \param	buf_size		܂͖߂̊ɏՕ̑傫
 * \param	callback		NULL܂͓]̍ŌŌĂԂ߂̊֐
 *
 * \warning \a b_shortpacketɂāAIN߲Ăɑ΂Ăް]̍ŌUSB
 * ]𐳂邽߂ɒZ߹(܂0߹)邱ƂӖ܂B
 * (ٸ)Ɗ荞݂OUT߲Ăɑ΂Ăް]̍Ō(Z߹ĎM)Ŏ
 * Iɓ]~܂B
 *
 * \return	֐Ȉꍇ\c 1AłȂ\c 0
 */
bool udd_ep_run(udd_ep_id_t ep, bool b_shortpacket,
		uint8_t * buf, iram_size_t buf_size,
		udd_callback_trans_t callback);
/**
 * \brief ߲ĂŐis̓]𒆎~
 *
 * ]is̏ꍇA͒~A]̍Ō}邽߂ɓo^ꂽĂ
 * ߂Ă΂܂B
 * : ݵ߲Ă͔F؂܂B
 *
 * \param	ep	~߲
 */
void udd_ep_abort(udd_ep_id_t ep);

#endif

//@}


/**
 * \name Ǘ
 *
 * ȉ̊֐͍ŕKvƂʂȌ֔ԂƂ𑕒uɋ܂B
 */
//@{
void udd_test_mode_j(void);
void udd_test_mode_k(void);
void udd_test_mode_se0_nak(void);
void udd_test_mode_packet(void);
//@}


/**
 * \name UDDɒ񋟂邽߂UDCĂі߂
 *
 * ȉ̌Ăі߂UDDɂĎgp܂B
 */
//@{

/**
 * \brief SETUPv̕ƊǗ
 *
 * ײނSETUP߯ĂMꂽɂĂт܂B\c udd_g_ctrlreqSETUP
 * Ăް܂݂܂B̌Ăі߂SETUPv󂯓ȂA\c 1Ԃč
 * IIް𑗂܂͎󂯂邽߂\c udd_g_ctrlreqXV܂B
 *
 * \return	v󂯓ꂽꍇ\c 1AłȂ\c 0
 */
extern bool udc_process_setup(void);

/**
 * \brief UDCؾ
 *
 * UDC͑SĂ̌`ԐݒؾĂ܂B
 */
extern void udc_reset(void);

/**
 * \brief SOFNƂ}邽
 *
 * UDC͋ꂽSĂUDIɍ}𑗂Ȃ΂Ȃ܂B
 */
extern void udc_sof_notify(void);

//@}

//@}

#ifdef __cplusplus
}
#endif
#endif // _UDD_H_
